package com.github.roschlau.adventofcode.core.solvers.y2020

import com.github.roschlau.adventofcode.core.args
import kotlinx.coroutines.runBlocking
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.MethodSource

class Day3Test {

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part1Args")
    fun `part 1`(input: String, solution: String) = runBlocking {
        assertEquals(solution, Day3.solvePart1(input))
    }

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part2Args")
    fun `part 2`(input: String, solution: String) = runBlocking {
        assertEquals(solution, Day3.solvePart2(input))
    }

    @Suppress("unused")
    companion object {
        @JvmStatic
        fun part1Args() = args(
            testInput to "7",
            input to "167",
        )

        @JvmStatic
        fun part2Args() = args(
            testInput to "336",
            input to "736527114",
        )
    }
}

private val testInput =
    """
    ..##.......
    #...#...#..
    .#....#..#.
    ..#.#...#.#
    .#...##..#.
    ..#.##.....
    .#.#.#....#
    .#........#
    #.##...#...
    #...##....#
    .#..#...#.#
    """.trimIndent()

private val input =
    """
    .............#...#....#.....##.
    .#...##.........#.#.........#.#
    .....##......#.......#.........
    .......#...........#.#.........
    #...........#...#..#.#......#..
    .........##....#.#...#.........
    .....#.........#.#...........#.
    ....#...............##....##...
    #.#.............#..#.......#.#.
    ...#...........................
    ......#..#....#.............#..
    ........#......#.......#.......
    ....#.....#..#.#...#.........#.
    ..#.#.......#.##...#....#.....#
    ...........#.........#..#......
    #...........#.#..#...#.#.#....#
    ........#......................
    ....#.#.....#....#.......#..#..
    .............................#.
    ....##..........#.....##......#
    ......#.....................#..
    ..#.....##.......#.............
    ....#.#..............#.#.......
    ..#.#........#.....#..##.......
    .....#...##.........##....#.#..
    .#....#..#..#...........#......
    .............#.....##........#.
    ..#....#............#.........#
    ###..........#........#.......#
    #...#..#.#.#.........#..#......
    ..#....#......#.............#..
    #...#........#..#...#.....#....
    .#..........#.#........#.......
    #.....#.........#..#......#....
    ....#....##........#......#....
    .......#....#.....#..#..#.....#
    .........#...#.#...#.##........
    .##.##...........#..##..#......
    .#.##....#........#...#........
    .......##.........##.####.....#
    ....#..##....#.................
    .#........#..........#.........
    ##....##..........##........#..
    #......#...........#....#..#...
    .......#..#....##..##.....#....
    .........#.#.#...#.....#.......
    ......#...#...#....#......#....
    ##....#..........#....##....##.
    ###.........#...#...#..........
    #.....##.#........#.......#....
    #...............#...##.#......#
    ..#.....####.###......#......#.
    ....#.......#..........#.......
    ....##..............#.#.#......
    .......##..#.......#...........
    ..#.......##....#.......###...#
    ........#...#.......#.#...#....
    .........##....#..#....#.......
    ............#.#.......#.#......
    .....#.....#...#....#.##.......
    .......#.........#.......#.....
    .#..#...#.....#............#.##
    .......#.#......##.............
    ##.#......#.....#.#............
    .#....#.....#............#...#.
    .........#.......#.#...........
    #............#.##...#..#...#.#.
    ......#....#.......#....#......
    ..........#........#..#.#......
    #..##.......#.........#..#.....
    .........#.....##........#.#..#
    ..#................#...........
    ....#..#........##.........#..#
    ###...#....##.#......##.......#
    .......#......##..#.......#....
    .......###...#...#..........##.
    ................#.......#......
    .#......##.##........#.........
    ....##.#.....##.......#........
    ...........#...........#.....#.
    ..#........#..#.#...#.#........
    #...............#...#.##.##.#.#
    ................#.......#......
    .#..#......#........#.#........
    ...##..#.......#.......#..#....
    .#.....#.#....##..#........#...
    ........##......#..........#...
    .#.......#.......#...#..#......
    .#..##.....#....#............#.
    ...#..........#....#........#..
    ..#.#..#.......#.#.##..........
    #........###.....#.#.......#.##
    .....#....##.............#.#..#
    ..##............#...##.........
    ...#.........#...........#.....
    ...#......#.#...#..###.........
    .............#...##............
    .....##..##.####.#..#......#.#.
    .#...#.....#.....#.#.....#.....
    .........#.......###.....#..##.
    .##.#..#..........#.##.#.#.....
    .#...#...#.#.##......#..#......
    .............#......#......#...
    #.....................#......#.
    ...#.....#.....#....#........#.
    ................##..#....#..#..
    #.###...#.....................#
    ...#..#....#.......#.........#.
    ...........#..#..#...........#.
    .......#..#......#....#.#......
    ..........#......#..#....#.....
    .#.#.....#...#.#...#...#.#....#
    .....#.......#............#...#
    #.#....#......#......#........#
    .#.#..#.........##...#.........
    #..###..#......................
    ..#.#..#.......................
    .##.....#...#......#..#........
    ...#...........#...#.......##..
    ..#...........#........#.......
    ........#....#.....#.#.........
    ..........#...........#.....#..
    ......#...#...##.#.............
    .#...#...##....................
    ............###.........#......
    .#.#...................#..#....
    ....#.#...#.#........#.#.......
    ....#...#...........#.......#.#
    ...........#............#...##.
    .....####....#.#......#.#......
    .##.............#............#.
    ......#.........#............##
    #.#....#...##....#.......#....#
    .....#.#....#..#..#...#..#.#..#
    .........................#.....
    ......#.#....###.......#....#..
    .....................##.#...#.#
    ..#.....#.#.#...#...#..........
    ........#..##........#...#...#.
    ..........#.#.##....#....##....
    .............#..#..............
    ..#.##..#.......#...#..#..##..#
    ..#..#....#.#..........#..#....
    ..........#....#...#......#....
    .##...#.......................#
    .#.....#....#..........#.......
    ...........#..#......##.....#..
    ......###.#..##....#...#.##....
    .......#..#.#....#.............
    ...#..#......##.........###.#..
    ...........#............##...#.
    ...#...#...........##.....#....
    ..................#............
    .#.#.#...#..............#..##..
    #.#....#........#.........#.##.
    #.#.#.......#.....#..........#.
    ...##.....##.#.....#...........
    .#....#..............##...##..#
    ........##.....................
    #..#..#.....###.............#..
    .......#...........#...........
    .........#.....................
    .......#...#...#.....##........
    ......#.........#........#.....
    ...#....##..#.####.#.......#.#.
    .....#..#......#........#.##..#
    .##....#......##......#...###..
    ..###.#........##.#...#.......#
    ............#......##....#.#...
    .....#....##..##............##.
    ......##....#.#...#....#.#..#.#
    .......#.........#.#.....#.#...
    .......#.#....#................
    .##...###..#.....#............#
    #.#......#.#..#..#.#...#..#..#.
    ..#.#.#.....#............#...##
    .##....###.........#..#........
    .#..#.#..#.#....#.........##.#.
    ....#..#...##.##........#......
    ........#.#....##....#....#....
    .......#..#..#.#..............#
    #....#....#.....#....#.........
    .#.###...#....#.......#........
    .........#.#....##....#...#....
    ....#.............#.....##.##..
    .....#.....#...##..#.#.##...##.
    .........#..#................##
    ...##..##......#.....#........#
    .#....#.....#.#......#..###....
    #.....#..#.....................
    ....#.#...#.#.................#
    .....##..................#.....
    #....##...#.##..###...#........
    ##.#.........#.......#....#....
    .#.#.............##..#.##......
    ...#.#..............#......#...
    .............#.........#.....#.
    #.......#........#......#.....#
    .....#..............#.##.#.....
    #......##...................#..
    ##.#.....#..........#........#.
    #...........##...........#.....
    .#...#.....#..#..##....#.......
    .....#.........#....##.#.......
    #........#......#.............#
    .#..................####.#.....
    #...#......#....##...#.#..#..#.
    ............#.#............#...
    ............#........#.#..###..
    .#..#..#..#.#.#.....#.#........
    #.....#..#.#...#..#..#........#
    #................#....#..#.....
    ....#..#..#.#......#.#..#.....#
    .#..#.......#...##.#.#.....#..#
    #.....................#.......#
    .............#.......#...#.....
    ....#......#.........###.##....
    ....#..#.......#.#........#....
    ....#...#....#.#....#..........
    ...#..#......#.............#...
    .......###.#.........#....#.#..
    ..#.....##.....................
    .#.#...........#..##....#......
    ..........##.#....#.#..........
    ...........#.#..#.#..#.#.......
    ..........#..#...#.....##......
    .....#.........#...#.#..#......
    #.#................#..........#
    ...#.....##.#..#...#.##.......#
    .....##...........#............
    .....#...#...#...#.#.....#.....
    ...........##..................
    .........#................#....
    ......#.....#.#...#.......#....
    ...#...#........#...#...#.#.#..
    ...............##..#....##...#.
    ...#.#...........##.......##..#
    ...........#............#......
    .#....#.#.......##.#.#.#.......
    .....#.#..#.#.#................
    .#............#...#.#..........
    .....#.......#.#.......#.....#.
    #....#...........#...#....##...
    ..#...#..##.....#....#..#......
    #.#.........#..#.#..#.#......#.
    ................#......##......
    #........#..............#....#.
    ........#..#.#........#..#..#..
    #..........#......#............
    ..##.......#..#.......#....#...
    .#........#..#..#.#.......##...
    ................#..............
    #.................#...........#
    ##..#...................#....##
    #..#....#.....#.#..#.#.#......#
    #................#.#.#...#.....
    .............#..#...#..##...#.#
    #..................#...........
    ..............#..#.....##.....#
    ..#...............#.#..........
    .....#......#....#..#...#......
    .#......#...##.....###.....#...
    ...##...##.##....#.#.#..#......
    ....#.#.......#..##....#.##....
    ...#.........#.#.....#...#...##
    .##.#.........##..#.##..#......
    .#...#......#......#.........#.
    .............#.................
    ..........#..............#.....
    ##...........#...#...###....#..
    ....#...............#..........
    .......####.....#......#.......
    ........#..........#..#........
    ..#.......#..#.................
    ......#.#..##...##....#........
    .##...#........#...#....#...#..
    .......................#.......
    .........##..#..#...#....##...#
    ..#..#...#.....#.........#..#..
    .......#....#.........#...#..#.
    .............#.................
    .....##..#.....###....##.#.....
    ....#.#..#..#.#.....##....#..#.
    ......#..#..............#.##..#
    ..#..#......#.#.........#..#...
    ..........#.#..#....#.....#....
    .....................#.........
    ...#.....#.......##..#.#.......
    .....#...#..........###....#.#.
    ......#.....##............#...#
    .......#..........#.#..#...#..#
    #...#..#...........#..##..#....
    .#......#.......##.....#..#....
    ...#..#....#.......##......#...
    ........#.......##...#.......#.
    .....#........#................
    ......#........#....#..........
    ...#....#....###.........#.#...
    ##..............#......#..#.#..
    .........##....#........#..#.#.
    .......#.##.#........#........#
    .....###..#..#...........#....#
    .......#....##.......#.#...#...
    #..............#.#....#..#...#.
    #..#....#..#.#............#..#.
    .#...##.#..................#...
    ...#...............##.........#
    ###..............#.#..#.#.#....
    .#......#.#.....##.......#.....
    ...#.................#.#.......
    .#...#....#...#..#......#...#..
    ...##....#........#.#.#..#.....
    ..#.....#........#....#.#......
    ...........#.#...#.............
    ......#.....#.....#.........#..
    .#.##.###...#.##.......#.......
    .............#....#.......#....
    ..............#...........#....
    .............#..#.#.....#....#.
    .......#........##...##..##....
    ..##...#............#..#......#
    .............#...##.....#......
    .#...##..##.#.........#.##...#.
    """.trimIndent()
